#include "stdafx.h"


Answer::Answer()
{
	isPrintingAnswer = false;
	rectangles.clear();
	binIndex.clear();
	inputIndex.clear();
}

void Answer::Init(Input input)
{
	isPrintingAnswer = false;
	rectangles.clear();
	binIndex.clear();
	inputIndex.clear();

	int n = input.CountRectangles();
	
	for(int i = 0; i < n; i ++)
	{
		Rect r;
		r.x = 0;
		r.y = 0;
		r.width = input.GetRectangle(i).width;
		r.height = input.GetRectangle(i).height;

		if(r.width < r.height)
		{
			swap(r.width, r.height);
		}

		rectangles.push_back(r);
		binIndex.push_back(i);
		inputIndex.push_back(i);
	}
}

void Answer::AddRectangle(Rect _rectangle, int _binIndex, int _inputIndex)
{
	rectangles.push_back(_rectangle);
	binIndex.push_back(_binIndex);
	inputIndex.push_back(_inputIndex);
}

void Answer::operator = (Answer a)
{
	if(isPrintingAnswer) return;

	rectangles = a.rectangles;
	binIndex = a.binIndex;
	inputIndex = a.inputIndex;
}

void Answer::CheckMin(Answer answer)
{
	if(isPrintingAnswer) return;

	if(answer.GetNumberOfBins() < GetNumberOfBins())
	{
		* this = answer;
	}
}

int Answer::GetNumberOfBins()
{
	return * max_element(binIndex.begin(), binIndex.end()) + 1;
}

void Answer::saveAnswerToFile(const char * fileName)
{
vector<int> index(inputIndex.size());
	
	for(size_t i = 0; i < inputIndex.size(); i ++)
	{
		index[inputIndex[i]] = i;
	}
	
	FILE * file;
	fopen_s(& file, fileName, "w");

	fprintf(file, "%d\n", GetNumberOfBins());

	for(size_t j = 0; j < inputIndex.size(); j ++)
	{
	int i = index[j];

		int binNumber = binIndex[i] + 1;
		int x = rectangles[i].x;
		int y = rectangles[i].y;

		if(rectangles[i].width <= rectangles[i].height)
			fprintf(file, "%d %d %d b\n", binNumber, x, y);
		else
			fprintf(file, "%d %d %d a\n", binNumber, x, y);
	}

	fclose(file);
}