#include "stdafx.h"


bool DecreasingAreaCMP(const RectSize & first, const RectSize & second)
{
	return (first.width * first.height) > (second.width * second.height);
}

bool DecreasingSideCMP(const RectSize & first, const RectSize & second)
{
	if(min(first.width, first.height) > min(second.width, second.height))
		return true;

	if(min(first.width, first.height) == min(second.width, second.height))
		if(max(first.width, first.height) > max(second.width, second.height))
			return true;

	return false;
}

Input::Input(const char * fileName)
{
int n, height, width;
FILE * inputFile;	

	totalArea = 0;
	rectangles.clear();

	fopen_s(& inputFile, fileName, "r");
	
	fscanf_s(inputFile, "%d", & n);
	
	fscanf_s(inputFile, "%d %d", & boxWidth, & boxHeight);
	
	for(int i = 0; i < n; i ++)
	{
		fscanf_s(inputFile, "%d %d", & width, & height);
		
		RectSize r;
		r.height = height;
		r.width = width;
		r.inputIndex = i;
		
		totalArea += width * height;
		rectangles.push_back(r);
	}
	
	fclose(inputFile);
}

int Input::GetBoxHeight() const
{
	return boxHeight;
}

int Input::GetBoxWidth() const
{
	return boxWidth;
}

int Input::GetTotalArea() const
{
	return totalArea;
}

int Input::CountRectangles() const
{
	return rectangles.size();
}

RectSize Input::GetRectangle(int index) const
{
	if(0 <= index && index < CountRectangles())
		return rectangles[index];
	
	return RectSize();
}

void Input::SortDecreasingArea()
{
	sort(rectangles.begin(), rectangles.end(), DecreasingAreaCMP);
}

void Input::SortDecreasingSide()
{
	sort(rectangles.begin(), rectangles.end(), DecreasingSideCMP);
}

void Input::RandomShuffle(int swaps)
{
	for(int i = 0; i < swaps; i ++)
	{
		int idx1 = rand() % rectangles.size();
		int idx2 = rand() % rectangles.size();

		swap(rectangles[idx1], rectangles[idx2]);
	}
}

