#pragma once

#include "stdafx.h"



class Solver
{

public:
	
	Solver(Timer *);

	// Best fit (Used only after sortin the input)

	Answer Guillotine(const Input &, bool, GuillotineBinPack::FreeRectChoiceHeuristic, GuillotineBinPack::GuillotineSplitHeuristic);
	
	Answer MaxRects(const Input &, MaxRectsBinPack::FreeRectChoiceHeuristic);

	Answer Shelf(const Input &, ShelfBinPack::ShelfChoiceHeuristic, GuillotineBinPack::FreeRectChoiceHeuristic, GuillotineBinPack::GuillotineSplitHeuristic);

	Answer Skyline(const Input &, SkylineBinPack::LevelChoiceHeuristic);


	// Global Algorithms

	Answer MaxRectsGlobal(const Input &, MaxRectsBinPack::FreeRectChoiceHeuristic);

	Answer SkylineGlobal(const Input &, SkylineBinPack::LevelChoiceHeuristic);

	Answer GuillotineGlobal(const Input &, bool, GuillotineBinPack::FreeRectChoiceHeuristic, GuillotineBinPack::GuillotineSplitHeuristic);


private:
	
	Timer * timer;

};
