#include "stdafx.h"


Timer::Timer()
{
	Timer(0, 0);
}

Timer::Timer(__int64 firstRunTime, __int64 secondRunTime)
{
	SolversState = 0;
	SolversTime[0] = 1LL << 60;
	SolversTime[1] = firstRunTime;
	SolversTime[2] = secondRunTime;
}

void Timer::NextState()
{
	SolversState ++;
}

bool Timer::TimeLeft()
{
	return (GetElapsedTime() < SolversTime[SolversState]);
}

inline __int64 Timer::GetElapsedTime()
{
__int64 creationTime, exitTime, kernelTime, userTime;	
	
	::GetThreadTimes(::GetCurrentThread(), (FILETIME*)&creationTime, (FILETIME*)&exitTime, (FILETIME*)&kernelTime, (FILETIME*)&userTime);

	kernelTime /= 10000;
	userTime /= 10000;

	__int64 totalTime = (userTime + kernelTime);

	return totalTime;


	//return double(clock()) / double(CLOCKS_PER_SEC);
}

void Timer::operator = (Timer timer)
{
	//startTime = timer.startTime;
	SolversState = timer.SolversState;
	SolversTime[0] = timer.SolversTime[0];
	SolversTime[1] = timer.SolversTime[1];
	SolversTime[2] = timer.SolversTime[2];
}